<?php

namespace Magento\FDPPaymentGateway\Controller\Helper;

class Cdata extends \Magento\Framework\App\Action\Action
{
	protected $_pageFactory;
	protected $scopeConfig;
	protected $cdhelper;

	public function __construct(
		\Magento\Framework\App\Action\Context $context,
		\Magento\Framework\View\Result\PageFactory $pageFactory,
		\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
		\Magento\FDPPaymentGateway\Helper\Cdata $cdhelper
	)
	{
		$this->_pageFactory = $pageFactory;
		$this->scopeConfig = $scopeConfig;
		$this->cdhelper = $cdhelper;
		return parent::__construct($context);
	}

	public function execute()
	{
		$json = json_decode(file_get_contents('php://input'), true);
		$k = $this->scopeConfig->getValue('payment/fdp_gateway/key');
		$this->getResponse()->setHeader('Content-type', 'application/json');
		$this->getResponse()->setBody(json_encode(['cdata' => $this->cdhelper->getCdata($json, $k)]));
		$this->getResponse()->sendResponse();
		exit;
	}

}
