<?php

namespace Magento\FDPPaymentGateway\Helper;

use \Magento\Framework\App\Helper\AbstractHelper;

class Cdata extends AbstractHelper
{

	public function getCdata($d, $sharedKey) {
        if(isset($d['response_code']) || isset($d['transaction_id']) || isset($d['cc_number_hash']) || isset($d['bin']) || isset($d['card_type']) || isset($d['auth_code']) || strpos($d['amount'], '&') !== false) return 'err1';
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $order = $objectManager->create('Magento\Sales\Model\Order')->load($d['order_id']);
        $sessId = md5($d['order_id'] . $sharedKey);
        if(!$order || ($d['session_id'] != $sessId)) return 'err2';
        if($order->getCustomerEmail() != $d['email']) return 'err3';
        if((round(floatval($order->getBaseGrandTotal()) * 100) != $d['amount']) || ($order->getBaseCurrencyCode() != $d['currency'])) return 'err4';
        
        $data = array();
        foreach($d as $k => $w) if($w) $data[$k] = $w;
        # build query
        $query = '';
        foreach($data as $key => $value)
            $query .= ($query ? '&' : '') . $key .'='. $value;
        
        # add shared key binary string
        $l = strlen($sharedKey)/2;
        $sharedKeyBin = '';
        for($i=1; $i<=$l; ++$i)
            $sharedKeyBin .= pack('H*', substr($sharedKey, 2*$i-2, 2));
        
        $query .= $sharedKeyBin;
        
        # hash
        return hash('sha256', $query);
    }

}

?>
