<?php

namespace Magento\FDPPaymentGateway\Model\Ui;

use Magento\FDPPaymentGateway\Gateway\Config\Config;
use Magento\Checkout\Model\ConfigProviderInterface;

/**
 * Class ConfigProvider
 */
final class ConfigProvider implements ConfigProviderInterface
{
    const CODE = 'fdp_gateway';
    private $config;

    public function __construct(Config $config) {
    	$this->config = $config;
    }
    
    public function getConfig() {
    	$objectManager = \Magento\Framework\App\ObjectManager::getInstance();
    	$cart = $objectManager->get('\Magento\Checkout\Model\Cart');
    	$q_id = $cart->getQuote()->getId();
    	$store = $objectManager->get('Magento\Framework\Locale\Resolver');
    	
        return [
            'payment' => [
                self::CODE => [
                    'gateway' => $this->config->getGateway(),
                	'pos_id' => $this->config->getPosId(),
                	'test' => $this->config->getTest(),
                	'id' => $q_id,
                	'lang' => substr($store->getLocale(), 3, 2),
                	'logo' => $this->config->getLogo()
                ]
            ]
        ];
    }
}
